
/* Chrysalide - Outil d'analyse de fichiers binaires
 * dwarf.h - prototypes pour le support du format Dwarf
 *
 * Copyright (C) 2009-2017 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _FORMAT_DWARF_DWARF_H
#define _FORMAT_DWARF_DWARF_H


#include "../../core/formats.h"



#define G_TYPE_DWARF_FORMAT            g_dwarf_format_get_type()
#define G_DWARF_FORMAT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), g_dwarf_format_get_type(), GDwarfFormat))
#define G_IS_DWARF_FORMAT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_dwarf_format_get_type()))
#define G_DWARF_FORMAT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_DWARF_FORMAT, GDwarfFormatClass))
#define G_IS_DWARF_FORMAT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_DWARF_FORMAT))
#define G_DWARF_FORMAT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_DWARF_FORMAT, GDwarfFormatClass))


/* Format de débogage DWARF (instance) */
typedef struct _GDwarfFormat GDwarfFormat;

/* Format de débogage DWARF (classe) */
typedef struct _GDwarfFormatClass GDwarfFormatClass;


/* Indique si le format peut être pris en charge ici. */
FormatMatchStatus dwarf_is_matching(GBinContent *, GExeFormat *, void *, char **);

/* Indique le type défini pour un format de débogage DWARF. */
GType g_dwarf_format_get_type(void);



#endif  /* _FORMAT_DWARF_DWARF_H */
